#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n;
    long  brojacO=0, brojacA=0, brojacB=0, brojacAB=0;
    cin>>n;
    long krv[4];
    long p[n][2];
    bool moguce=true;
    long fao=0, fbo=0, fabo=0, faba=0, fabb=0;

    string a;
    long b;
    int c;

    for(int i=0;i<4;i++)
        cin>>krv[i];

    for(int i=0;i<n;i++)
    {
        cin>>a>>b;

        if(a[0]=='O')
        {
            c=1;
            brojacO += b;
        }

        if(a[0]=='A')
        {
            if(a[1]=='B')
            {
                c=4;
                brojacAB += b;
            }else
            {
                c=2;
                brojacA += b;
            }
        }

        if(a[0]=='B')
        {
            c=3;
            brojacB += b;
        }

        p[i][0]=c;
        p[i][1]=b;
    }


if(brojacA+brojacAB+brojacB+brojacO > krv[0]+krv[1]+krv[2]+krv[3])
    moguce=false;
else
    {
    if(brojacO>krv[0])
        moguce=false;
    else
        {
            krv[0] -= brojacO;
            brojacO=0;


            if(brojacA > krv[1])
            {
                brojacA -= krv[1];
                krv[1]=0;
            }else
            {
                krv[1] -= brojacA;
                brojacA=0;
            }

            if(brojacB > krv[2])
            {
                brojacB -= krv[2];
                krv[2]=0;
            }else
            {
                krv[2] -= brojacB;
                brojacB=0;
            }

            if(brojacAB > krv[3])
            {
                brojacAB -= krv[3];
                krv[3]=0;
            }else
            {
                krv[3] -= brojacAB;
                brojacAB=0;
            }


                    if(krv[0]>=brojacA)
                    {
                        krv[0] -= brojacA;
                        fao=brojacA;
                        brojacA=0;
                    }else
                    {
                        moguce=false;

                    }

                    if(krv[0]>=brojacB && moguce==true)
                    {
                        krv[0] -= brojacB;
                        fbo=brojacB;
                        brojacB=0;
                    }else
                    {
                        moguce=false;

                    }

                    if(brojacAB>krv[0] && moguce==true)
                    {
                        brojacAB -= krv[0];
                        fabo=krv[0];
                        if(brojacAB>krv[1])
                        {
                            brojacAB -= krv[1];
                            faba=krv[1];
                            if(brojacAB>krv[2])
                            {
                                moguce=false;

                            }else
                            {
                                krv[2] -= brojacAB;
                                fabb=brojacAB;
                                brojacAB=0;
                            }
                        }else
                        {
                            krv[1] -= brojacAB;
                            faba=brojacAB;
                            brojacAB=0;
                        }

                    }else
                    {
                        krv[0] -= brojacAB;
                        fabo=brojacAB;
                        brojacAB=0;
                    }
                }

            }


if(moguce==false)
    cout<<"nemoguce";
else{
    cout<<"moguce"<<endl;
    for(int i=0;i<n;i++)
    {
        if(p[i][0]==1)
             printf("%d 0 0 0\n",p[i][1]);
        else
        {
            if(p[i][0]==2 && fao>0)
            {
                 printf("%d %d 0 0\n",fao,p[i][1]-fao);
            }
            else if(p[i][0]==3 || p[i][0]==4)
            {
                if(p[i][0]==3 && fbo>0)
                {
                    printf("%d 0 %d 0\n",fbo,p[i][1]-fbo);
                }
                else if(p[i][0]==4)
                {
                    if(fabo>0 || faba>0 || fabb>0)
                    {
                        printf("%d %d %d %d\n",fabo,faba,fabb,p[i][1]-fabo-faba-fabb);
                    }else
                        printf("0 0 0 %d\n",p[i][1]);
                }else
                {
                    printf("0 0 %d 0\n",p[i][1]);
                }
            }else
            {
                 printf("0 %d 0 0\n",p[i][1]);
            }
        }
    }
}}